Next: Configuration, Previous: Commands, Up: Invoking DIRMNGR [Contents][Index]

### 3.2 Option Summary

Note that all long options with the exception of `--options` and `--homedir` may also be given in the configuration file after stripping off the two leading dashes.

`--options file` ¶

  Reads configuration from file instead of from the default per-user configuration file. The default configuration file is named `dirmngr.conf` and expected in the home directory.

`--homedir dir` ¶

  Set the name of the home directory to dir. This option is only effective when used on the command line. The default is the directory named `.gnupg` directly below the home directory of the user unless the environment variable `GNUPGHOME` has been set in which case its value will be used. Many kinds of data are stored within this directory.

`-v`
`--verbose` ¶

  Outputs additional information while running. You can increase the verbosity by giving several verbose commands to DIRMNGR, such as `-vv`.

`--log-file file` ¶

  Append all logging output to file. This is very helpful in seeing what the agent actually does. Use `socket://` to log to socket.

`--debug-level level` ¶

  Select the debug level for investigating problems. level may be a numeric value or by a keyword:

  `none`

    No debugging at all. A value of less than 1 may be used instead of the keyword.

  `basic`

    Some basic debug messages. A value between 1 and 2 may be used instead of the keyword.

  `advanced`

    More verbose debug messages. A value between 3 and 5 may be used instead of the keyword.

  `expert`

    Even more detailed messages. A value between 6 and 8 may be used instead of the keyword.

  `guru`

    All of the debug messages you can get. A value greater than 8 may be used instead of the keyword. The creation of hash tracing files is only enabled if the keyword is used.

  How these messages are mapped to the actual debugging flags is not specified and may change with newer releases of this program. They are however carefully selected to best aid in debugging.

`--debug flags` ¶

  Set debugging flags. This option is only useful for debugging and its behavior may change with a new release. All flags are or-ed and may be given in C syntax (e.g. 0x0042) or as a comma separated list of flag names. To get a list of all supported flags the single word "help" can be used.

`--debug-all` ¶

  Same as `--debug=0xffffffff`

`--tls-debug level` ¶

  Enable debugging of the TLS layer at level. The details of the debug level depend on the used TLS library and are not set in stone.

`--debug-wait n` ¶

  When running in server mode, wait n seconds before entering the actual processing loop and print the pid. This gives time to attach a debugger.

`--disable-check-own-socket` ¶

  On some platforms `dirmngr` is able to detect the removal of its socket file and shutdown itself. This option disable this self-test for debugging purposes.

`-s` ¶
`--sh`
`-c`
`--csh`

  Format the info output in daemon mode for use with the standard Bourne shell respective the C-shell. The default is to guess it based on the environment variable `SHELL` which is in almost all cases sufficient.

`--force` ¶

  Enabling this option forces loading of expired CRLs; this is only useful for debugging.

`--use-tor` ¶
`--no-use-tor`

  The option `--use-tor` switches Dirmngr and thus GnuPG into “Tor mode” to route all network access via Tor (an anonymity network). Certain other features are disabled in this mode. The effect of `--use-tor` cannot be overridden by any other command or even by reloading dirmngr. The use of `--no-use-tor` disables the use of Tor. The default is to use Tor if it is available on startup or after reloading dirmngr.

`--standard-resolver` ¶

  This option forces the use of the system’s standard DNS resolver code. This is mainly used for debugging. Note that on Windows a standard resolver is not used and all DNS access will return the error “Not Implemented” if this option is used. Using this together with enabled Tor mode returns the error “Not Enabled”.

`--recursive-resolver` ¶

  When possible use a recursive resolver instead of a stub resolver.

`--resolver-timeout n` ¶

  Set the timeout for the DNS resolver to N seconds. The default are 30 seconds.

`--connect-timeout n`
`--connect-quick-timeout n` ¶

  Set the timeout for HTTP and generic TCP connection attempts to N seconds. The value set with the quick variant is used when the –quick option has been given to certain Assuan commands. The quick value is capped at the value of the regular connect timeout. The default values are 15 and 2 seconds. Note that the timeout values are for each connection attempt; the connection code will attempt to connect all addresses listed for a server.

`--listen-backlog n` ¶

  Set the size of the queue for pending connections. The default is 64.

`--allow-version-check` ¶

  Allow Dirmngr to connect to `https://versions.gnupg.org` to get the list of current software versions. If this option is enabled the list is retrieved in case the local copy does not exist or is older than 5 to 7 days. See the option `--query-swdb` of the command `gpgconf` for more details. Note, that regardless of this option a version check can always be triggered using this command:

             gpg-connect-agent --dirmngr 'loadswdb --force' /bye

`--keyserver name` ¶

  Use name as your keyserver. This is the server that `gpg` communicates with to receive keys, send keys, and search for keys. The format of the name is a URI: ‘scheme:[//]keyservername[:port]’ The scheme is the type of keyserver: "hkp" for the HTTP (or compatible) keyservers, "ldap" for the LDAP keyservers, or "mailto" for the Graff email keyserver. Note that your particular installation of GnuPG may have other keyserver types available as well. Keyserver schemes are case-insensitive. After the keyserver name, optional keyserver configuration options may be provided. These are the same as the `--keyserver-options` of `gpg`, but apply only to this particular keyserver.

  Most keyservers synchronize with each other, so there is generally no need to send keys to more than one server. The keyserver `hkp://keys.gnupg.net` uses round robin DNS to give a different keyserver each time you use it.

  If exactly two keyservers are configured and only one is a Tor hidden service (.onion), Dirmngr selects the keyserver to use depending on whether Tor is locally running or not. The check for a running Tor is done for each new connection.

  If no keyserver is explicitly configured, dirmngr will use the built-in default of `hkps://hkps.pool.sks-keyservers.net`.

  Windows users with a keyserver running on their Active Directory should use `ldap:///` for name to access this directory.

  For accessing anonymous LDAP keyservers name is in general just a `ldaps://ldap.example.com`. A BaseDN parameter should never be specified. If authentication is required the value of name is for example:

             keyserver ldaps://ldap.example.com/????bindname=uid=USERNAME
             %2Cou=GnuPG%20Users%2Cdc=example%2Cdc=com,password=PASSWORD

  Put this all on one line without any spaces and keep the ’%2C’ as given. Replace USERNAME, PASSWORD, and the ’dc’ parts according to the instructions received from the LDAP administrator. Note that only simple authentication (i.e. cleartext passwords) is supported and thus using ldaps is strongly suggested.

`--nameserver ipaddr` ¶

  In “Tor mode” Dirmngr uses a public resolver via Tor to resolve DNS names. If the default public resolver, which is `8.8.8.8`, shall not be used a different one can be given using this option. Note that a numerical IP address must be given (IPv6 or IPv4) and that no error checking is done for ipaddr.

`--disable-ipv4`
`--disable-ipv6` ¶

  Disable the use of all IPv4 or IPv6 addresses.

`--disable-ldap` ¶

  Entirely disables the use of LDAP.

`--disable-http` ¶

  Entirely disables the use of HTTP.

`--ignore-http-dp` ¶

  When looking for the location of a CRL, the to be tested certificate usually contains so called CRL Distribution Point (DP) entries which are URLs describing the way to access the CRL. The first found DP entry is used. With this option all entries using the HTTP scheme are ignored when looking for a suitable DP.

`--ignore-ldap-dp` ¶

  This is similar to `--ignore-http-dp` but ignores entries using the LDAP scheme. Both options may be combined resulting in ignoring DPs entirely.

`--ignore-ocsp-service-url` ¶

  Ignore all OCSP URLs contained in the certificate. The effect is to force the use of the default responder.

`--honor-http-proxy` ¶

  If the environment variable `http_proxy` has been set, use its value to access HTTP servers.

`--http-proxy host[:port]` ¶

  Use host and port to access HTTP servers. The use of this option overrides the environment variable `http_proxy` regardless whether `--honor-http-proxy` has been set.

`--ldap-proxy host[:port]` ¶

  Use host and port to connect to LDAP servers. If port is omitted, port 389 (standard LDAP port) is used. This overrides any specified host and port part in a LDAP URL and will also be used if host and port have been omitted from the URL.

`--only-ldap-proxy` ¶

  Never use anything else but the LDAP "proxy" as configured with `--ldap-proxy`. Usually `dirmngr` tries to use other configured LDAP server if the connection using the "proxy" failed.

`--ldapserverlist-file file` ¶

  Read the list of LDAP servers to consult for CRLs and certificates from file instead of the default per-user ldap server list file. The default value for file is `dirmngr_ldapservers.conf`.

  This server list file contains one LDAP server per line in the format

  HOSTNAME:PORT:USERNAME:PASSWORD:BASE_DN

  Lines starting with a ‘`#`’ are comments.

  Note that as usual all strings entered are expected to be UTF-8 encoded. Obviously this will lead to problems if the password has originally been encoded as Latin-1. There is no other solution here than to put such a password in the binary encoding into the file (i.e. non-ascii characters won’t show up readable).1

`--ldaptimeout secs` ¶

  Specify the number of seconds to wait for an LDAP query before timing out. The default are 15 seconds. 0 will never timeout.

`--add-servers` ¶

  This option makes dirmngr add any servers it discovers when validating certificates against CRLs to the internal list of servers to consult for certificates and CRLs.

  This option is useful when trying to validate a certificate that has a CRL distribution point that points to a server that is not already listed in the ldapserverlist. Dirmngr will always go to this server and try to download the CRL, but chances are high that the certificate used to sign the CRL is located on the same server. So if dirmngr doesn’t add that new server to list, it will often not be able to verify the signature of the CRL unless the `--add-servers` option is used.

  Note: The current version of dirmngr has this option disabled by default.

`--allow-ocsp` ¶

  This option enables OCSP support if requested by the client.

  OCSP requests are rejected by default because they may violate the privacy of the user; for example it is possible to track the time when a user is reading a mail.

`--ocsp-responder url` ¶

  Use url as the default OCSP Responder if the certificate does not contain information about an assigned responder. Note, that `--ocsp-signer` must also be set to a valid certificate.

`--ocsp-signer fpr|file` ¶

  Use the certificate with the fingerprint fpr to check the responses of the default OCSP Responder. Alternatively a filename can be given in which case the response is expected to be signed by one of the certificates described in that file. Any argument which contains a slash, dot or tilde is considered a filename. Usual filename expansion takes place: A tilde at the start followed by a slash is replaced by the content of `HOME`, no slash at start describes a relative filename which will be searched at the home directory. To make sure that the file is searched in the home directory, either prepend the name with "./" or use a name which contains a dot.

  If a response has been signed by a certificate described by these fingerprints no further check upon the validity of this certificate is done.

  The format of the FILE is a list of SHA-1 fingerprint, one per line with optional colons between the bytes. Empty lines and lines prefix with a hash mark are ignored.

`--ocsp-max-clock-skew n` ¶

  The number of seconds a skew between the OCSP responder and them local clock is accepted. Default is 600 (10 minutes).

`--ocsp-max-period n` ¶

  Seconds a response is at maximum considered valid after the time given in the thisUpdate field. Default is 7776000 (90 days).

`--ocsp-current-period n` ¶

  The number of seconds an OCSP response is considered valid after the time given in the NEXT_UPDATE datum. Default is 10800 (3 hours).

`--max-replies n` ¶

  Do not return more that n items in one query. The default is 10.

`--ignore-cert-extension oid` ¶

  Add oid to the list of ignored certificate extensions. The oid is expected to be in dotted decimal form, like `2.5.29.3`. This option may be used more than once. Critical flagged certificate extensions matching one of the OIDs in the list are treated as if they are actually handled and thus the certificate won’t be rejected due to an unknown critical extension. Use this option with care because extensions are usually flagged as critical for a reason.

`--hkp-cacert file`

  Use the root certificates in file for verification of the TLS certificates used with `hkps` (keyserver access over TLS). If the file is in PEM format a suffix of `.pem` is expected for file. This option may be given multiple times to add more root certificates. Tilde expansion is supported.

  If no `hkp-cacert` directive is present, dirmngr will make a reasonable choice: if the keyserver in question is the special pool `hkps.pool.sks-keyservers.net`, it will use the bundled root certificate for that pool. Otherwise, it will use the system CAs.

#### Footnotes

##### (1)

The `gpgconf` tool might be helpful for frontends as it enables editing this configuration file using percent-escaped strings.

Next: Configuration, Previous: Commands, Up: Invoking DIRMNGR [Contents][Index]